package cn.iocoder.yudao.module.system.service.extra;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.system.controller.admin.extra.vo.CheckInTabPageReqVO;
import cn.iocoder.yudao.module.system.dal.dataobject.extra.ElderlyExtraCheckInTabDO;
import cn.iocoder.yudao.module.system.dal.mysql.extra.ElderlyExtraCheckInTabMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.system.enums.ErrorCodeConstants.ELDERLY_EXTRA_CHECK_IN_TAB_NOT_EXISTS;

/**
 * （附件）入住登记表 Service 实现
 *
 * @author 管理员
 */
@Service
@Slf4j
public class ElderlyExtraCheckInTabServiceImpl implements ElderlyExtraCheckInTabService {

    @Resource
    private ElderlyExtraCheckInTabMapper mapper;

    @Override
    public Long create(ElderlyExtraCheckInTabDO createReqVO) {
        mapper.insert(createReqVO);
        return createReqVO.getId();
    }

    @Override
    public void update(ElderlyExtraCheckInTabDO updateReqVO) {
        validateExists(updateReqVO.getId());
        mapper.updateById(updateReqVO);
    }

    @Override
    public void delete(Long id) {
        validateExists(id);
        mapper.deleteById(id);
    }

    @Override
    public PageResult<ElderlyExtraCheckInTabDO> findPage(CheckInTabPageReqVO reqVO) {
        return mapper.selectPage(reqVO);
    }

    @Override
    public ElderlyExtraCheckInTabDO getDetail(Long id) {
        return validateExists(id);
    }

    @Override
    public List<ElderlyExtraCheckInTabDO> getListByElderId(Long elderId) {
        return mapper.selectList(
                new LambdaQueryWrapperX<ElderlyExtraCheckInTabDO>()
                        .eqIfPresent(ElderlyExtraCheckInTabDO::getElderId, elderId)
                        .orderByDesc(ElderlyExtraCheckInTabDO::getCreateTime)
        );
    }

    private ElderlyExtraCheckInTabDO validateExists(Long id) {
        ElderlyExtraCheckInTabDO record = mapper.selectById(id);
        if (record == null) {
            throw exception(ELDERLY_EXTRA_CHECK_IN_TAB_NOT_EXISTS);
        }
        return record;
    }

}
